import { action } from "./instructions.js";
import { pause } from "./pause.js";
export function call(operator) {
    return action(function* (resolve, reject) {
        try {
            let op = typeof operator === "function" ? operator() : operator;
            if (typeof op[Symbol.iterator] === "function") {
                resolve(yield* op);
            }
            else {
                //@ts-expect-error this is because we monkey-patch the tests
                resolve(yield* expect(op));
            }
        }
        catch (error) {
            reject(error);
        }
    });
}
function expect(promise) {
    return pause((resolve, reject) => {
        promise.then(resolve, reject);
        return () => { };
    });
}
//# sourceMappingURL=call.js.map