"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.call = void 0;
const instructions_js_1 = require("./instructions.js");
const pause_js_1 = require("./pause.js");
function call(operator) {
    return (0, instructions_js_1.action)(function* (resolve, reject) {
        try {
            let op = typeof operator === "function" ? operator() : operator;
            if (typeof op[Symbol.iterator] === "function") {
                resolve(yield* op);
            }
            else {
                //@ts-expect-error this is because we monkey-patch the tests
                resolve(yield* expect(op));
            }
        }
        catch (error) {
            reject(error);
        }
    });
}
exports.call = call;
function expect(promise) {
    return (0, pause_js_1.pause)((resolve, reject) => {
        promise.then(resolve, reject);
        return () => { };
    });
}
//# sourceMappingURL=call.js.map