"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.map = void 0;
function map(op) {
    return function (stream) {
        return {
            subscribe() {
                return {
                    *[Symbol.iterator]() {
                        let subscription = yield* stream.subscribe();
                        return {
                            *next() {
                                let next = yield* subscription.next();
                                if (next.done) {
                                    return next;
                                }
                                else {
                                    return { ...next, value: yield* op(next.value) };
                                }
                            },
                        };
                    },
                };
            },
        };
    };
}
exports.map = map;
//# sourceMappingURL=map.js.map